=== modified file 'm4/pandora_warnings.m4'
--- m4/pandora_warnings.m4	2010-12-24 00:04:05 +0000
+++ m4/pandora_warnings.m4	2010-12-25 19:54:38 +0000
@@ -417,6 +417,7 @@
     CXX_WARNINGS="+w +w2 -xwe -xport64 -errtags=yes ${CXX_WARNINGS_FULL} ${W_FAIL}"
     PROTOSKIP_WARNINGS="-erroff=attrskipunsup,doubunder,reftotemp,wbadinitl,identexpected,inllargeuse,truncwarn1,signextwarn,partinit,notused,badargtype2w,wbadinit"
     BOOSTSKIP_WARNINGS="-erroff=attrskipunsup,doubunder,reftotemp,inllargeuse,truncwarn1,signextwarn,inllargeint,hidef,wvarhidenmem"
+    INNOBASE_SKIP_WARNINGS="-erroff=attrskipunsup,doubunder,reftotemp,inllargeuse,truncwarn1,signextwarn,inllargeint,hidef,wvarhidenmem,notused,badargtype2w"
     NO_UNREACHED="-erroff=E_STATEMENT_NOT_REACHED"
     NO_WERROR="-errwarn=%none"
 

=== modified file 'plugin/innobase/buf/buf0buf.cc'
--- plugin/innobase/buf/buf0buf.cc	2010-12-24 00:04:05 +0000
+++ plugin/innobase/buf/buf0buf.cc	2010-12-25 19:54:38 +0000
@@ -941,14 +941,14 @@
 
 	/* Allocate the block descriptors from
 	the start of the memory block. */
-	chunk->blocks = chunk->mem;
+	chunk->blocks = static_cast<buf_block_struct *>(chunk->mem);
 
 	/* Align a pointer to the first frame.  Note that when
 	os_large_page_size is smaller than UNIV_PAGE_SIZE,
 	we may allocate one fewer block than requested.  When
 	it is bigger, we may allocate more blocks than requested. */
 
-	frame = ut_align(chunk->mem, UNIV_PAGE_SIZE);
+	frame = static_cast<unsigned char *>(ut_align(chunk->mem, UNIV_PAGE_SIZE));
 	chunk->size = chunk->mem_size / UNIV_PAGE_SIZE
 		- (frame != chunk->mem);
 
@@ -1213,7 +1213,8 @@
 
 	if (buf_pool_size > 0) {
 		buf_pool->n_chunks = 1;
-		buf_pool->chunks = chunk = mem_zalloc(sizeof *chunk);
+                void *chunk_ptr= mem_zalloc((sizeof *chunk));
+		buf_pool->chunks = chunk = static_cast<buf_chunk_t *>(chunk_ptr);
 
 		UT_LIST_INIT(buf_pool->free);
 
@@ -1302,7 +1303,8 @@
 	/* We create an extra buffer pool instance, this instance is used
 	for flushing the flush lists, to keep track of n_flush for all
 	the buffer pools and also used as a waiting object during flushing. */
-	buf_pool_ptr = mem_zalloc(n_instances * sizeof *buf_pool_ptr);
+        void *buf_pool_void_ptr= mem_zalloc(n_instances * sizeof *buf_pool_ptr);
+	buf_pool_ptr = static_cast<buf_pool_struct *>(buf_pool_void_ptr);
 
 	for (i = 0; i < n_instances; i++) {
 		buf_pool_t*	ptr	= &buf_pool_ptr[i];
@@ -1655,7 +1657,7 @@
 	buf_pool->old_pool_size = buf_pool->curr_pool_size;
 
 	/* Rewrite buf_pool->chunks.  Copy everything but max_chunk. */
-	chunks = mem_alloc((buf_pool->n_chunks - 1) * sizeof *chunks);
+	chunks = static_cast<buf_chunk_t *>(mem_alloc((buf_pool->n_chunks - 1) * sizeof *chunks));
 	memcpy(chunks, buf_pool->chunks,
 	       (max_chunk - buf_pool->chunks) * sizeof *chunks);
 	memcpy(chunks + (max_chunk - buf_pool->chunks),
@@ -1940,7 +1942,7 @@
 	buf_chunk_t*	chunk;
 
 	buf_pool_mutex_enter(buf_pool);
-	chunks = mem_alloc((buf_pool->n_chunks + 1) * sizeof *chunks);
+	chunks = static_cast<buf_chunk_t *>(mem_alloc((buf_pool->n_chunks + 1) * sizeof *chunks));
 
 	memcpy(chunks, buf_pool->chunks, buf_pool->n_chunks * sizeof *chunks);
 
@@ -3657,7 +3659,7 @@
 			mutex_exit(&block->mutex);
 			data = buf_buddy_alloc(buf_pool, zip_size, &lru);
 			mutex_enter(&block->mutex);
-			block->page.zip.data = data;
+			block->page.zip.data = static_cast<unsigned char *>(data);
 
 			/* To maintain the invariant
 			block->in_unzip_LRU_list
@@ -3680,7 +3682,7 @@
 		invocation of buf_buddy_relocate_block() on
 		uninitialized data. */
 		data = buf_buddy_alloc(buf_pool, zip_size, &lru);
-		bpage = buf_buddy_alloc(buf_pool, sizeof *bpage, &lru);
+		bpage = static_cast<buf_page_struct *>(buf_buddy_alloc(buf_pool, sizeof *bpage, &lru));
 
 		/* Initialize the buf_pool pointer. */
 		bpage->buf_pool_index = buf_pool_index(buf_pool);
@@ -3709,7 +3711,7 @@
 
 		page_zip_des_init(&bpage->zip);
 		page_zip_set_size(&bpage->zip, zip_size);
-		bpage->zip.data = data;
+		bpage->zip.data = static_cast<unsigned char *>(data);
 
 		mutex_enter(&buf_pool->zip_mutex);
 		UNIV_MEM_DESC(bpage->zip.data,
@@ -3863,7 +3865,7 @@
 		has been added to buf_pool->LRU and buf_pool->page_hash. */
 		data = buf_buddy_alloc(buf_pool, zip_size, &lru);
 		mutex_enter(&block->mutex);
-		block->page.zip.data = data;
+		block->page.zip.data = static_cast<unsigned char *>(data);
 
 		/* To maintain the invariant
 		block->in_unzip_LRU_list
@@ -4194,7 +4196,7 @@
 		write activity happening. */
 		if (buf_pool->n_flush[i] > 0) {
 			buf_pool_mutex_exit(buf_pool);
-			buf_flush_wait_batch_end(buf_pool, i);
+			buf_flush_wait_batch_end(buf_pool, static_cast<buf_flush>(i));
 			buf_pool_mutex_enter(buf_pool);
 		}
 	}

=== modified file 'plugin/innobase/include/hash0hash.h'
--- plugin/innobase/include/hash0hash.h	2010-12-18 04:43:40 +0000
+++ plugin/innobase/include/hash0hash.h	2010-12-25 19:54:38 +0000
@@ -314,10 +314,10 @@
 	cell_count2222 = hash_get_n_cells(OLD_TABLE);\
 \
 	for (i2222 = 0; i2222 < cell_count2222; i2222++) {\
-		NODE_TYPE*	node2222 = HASH_GET_FIRST((OLD_TABLE), i2222);\
+		NODE_TYPE*	node2222 = static_cast<NODE_TYPE *>(HASH_GET_FIRST((OLD_TABLE), i2222));\
 \
 		while (node2222) {\
-			NODE_TYPE*	next2222 = node2222->PTR_NAME;\
+			NODE_TYPE*	next2222 = static_cast<NODE_TYPE *>(node2222->PTR_NAME);\
 			ulint		fold2222 = FOLD_FUNC(node2222);\
 \
 			HASH_INSERT(NODE_TYPE, PTR_NAME, (NEW_TABLE),\

=== modified file 'plugin/innobase/plugin.am'
--- plugin/innobase/plugin.am	2010-12-24 00:04:05 +0000
+++ plugin/innobase/plugin.am	2010-12-25 19:54:38 +0000
@@ -327,6 +327,7 @@
 plugin_innobase_libpars_la_CXXFLAGS= \
 				     ${AM_CXXFLAGS} \
 				     ${PERMISSIVE_WARNINGS} \
+				     ${INNOBASE_SKIP_WARNINGS} \
 				     ${NO_WERROR} \
 				     -I$(top_builddir)/plugin/innobase/include \
 				     -I$(top_srcdir)/plugin/innobase/include \

